// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/11/19
// Update  : 2009/11/19
// Description : フォームの入力説明をtooltipで表示する
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var inputExplainExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'explainExtension', // 対象とするクラス
		tooltipColor : 'black', // tooltipの色 --> 'black','white','red','green'
		hideSpeed : 5000 // tooltipを自動非表示するまでの時間（ミリ秒） --> 自動で非表示にしない場合は0をセット
	},
	storage : {
		explain : [],
		dispTimer : null,
		hideTimer : null,
		fadeTimer : null,
		tooltip : null,
		content : null,
		shim : null
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		var elements = inputExplainExtension.getTargetElementsByClassName( inputExplainExtension.conf.targetClass );
		for ( var i = 0, len = elements.length; i < len; i++ ) {
			// 対象input要素のidを取得
			var id = inputExplainExtension.getTargetId(elements[i].className);
			// 説明文を取得
			var explain = elements[i].innerHTML;
			// 説明文を非表示にする
			var parent = elements[i].parentNode;
			parent.removeChild(elements[i]);
			// 対象input要素数だけLOOP
			for ( var x = 0, len2 = id.length; x < len2; x++ ) {
				// idと説明文のセットを保持
				var ary = new Array(id[x], explain);
				inputExplainExtension.storage.explain.push(ary);
				// 対象input要素にイベント付加
				var input = document.getElementById(id[x]);
				inputExplainExtension.addEvent(input, 'focus', inputExplainExtension.focus);
				inputExplainExtension.addEvent(input, 'blur', inputExplainExtension.blur);
			}
		}
		if ( elements && elements.length > 0 ) {
			// tooltip生成
			inputExplainExtension.createTooltip();
			// shim生成
			inputExplainExtension.createShim();
		}
	},
	//-----------------------------------------
	// focus時の処理
	//-----------------------------------------
	focus : function() {
		inputExplainExtension.view(this.id);
	},
	//-----------------------------------------
	// blur時の処理
	//-----------------------------------------
	blur : function() {
		inputExplainExtension.hide();
	},
	//-----------------------------------------
	// tooltipを表示する
	//-----------------------------------------
	view : function( id ) {
		for ( var i = 0, len = inputExplainExtension.storage.explain.length; i < len; i++ ) {
			var ary = inputExplainExtension.storage.explain[i];
			if ( ary[0] == id ) {
				// Timerリセット
				window.clearTimeout(inputExplainExtension.storage.dispTimer);
				window.clearTimeout(inputExplainExtension.storage.fadeTimer);
				window.clearTimeout(inputExplainExtension.storage.hideTimer);
				// tooltipの設定
				var input = document.getElementById(id);
				inputExplainExtension.storage.content.innerHTML = ary[1];
				var inputPos = inputExplainExtension.getElementPosition(input);
				var tooltipSize = inputExplainExtension.getElementSize(inputExplainExtension.storage.tooltip);
				inputExplainExtension.setPosition(inputExplainExtension.storage.tooltip, inputPos.top - tooltipSize.height, inputPos.left);
				inputExplainExtension.setOpacity(inputExplainExtension.storage.tooltip, 0);
				inputExplainExtension.storage.tooltip.style.visibility = 'visible';
				// shimの設定
				inputExplainExtension.setSize(inputExplainExtension.storage.shim, tooltipSize.width, tooltipSize.height);
				inputExplainExtension.setPosition(inputExplainExtension.storage.shim, inputPos.top - tooltipSize.height, inputPos.left);
				inputExplainExtension.storage.shim.style.visibility = 'visible';
				// fadeIn開始
				inputExplainExtension.fadeIn();
				break;
			}
		}
	},
	//-----------------------------------------
	// tooltipを非表示にする
	//-----------------------------------------
	hide : function() {
		// Timerリセット
		window.clearTimeout(inputExplainExtension.storage.dispTimer);
		window.clearTimeout(inputExplainExtension.storage.fadeTimer);
		window.clearTimeout(inputExplainExtension.storage.hideTimer);
		// fadeOut開始
		inputExplainExtension.fadeOut();
	},
	//-----------------------------------------
	// tooltipのフェード制御（表示）
	//-----------------------------------------
	fadeIn : function() {
		// 不透明度を取得
		var opacity = inputExplainExtension.getOpacity(inputExplainExtension.storage.tooltip);
		if ( 8.7 > opacity ) {
			// 不透明度セット
			inputExplainExtension.setOpacity(inputExplainExtension.storage.tooltip, opacity+1);
			inputExplainExtension.storage.dispTimer = window.setTimeout(inputExplainExtension.fadeIn, 50);
		} else {
			// 不透明度セット
			inputExplainExtension.setOpacity(inputExplainExtension.storage.tooltip, 8.7);
			// 非表示タイマーをセット
			if ( inputExplainExtension.conf.hideSpeed > 0 ) {
				inputExplainExtension.storage.hideTimer = window.setTimeout(inputExplainExtension.hide, inputExplainExtension.conf.hideSpeed);
			}
		}
	},
	//-----------------------------------------
	// tooltipのフェード制御（非表示）
	//-----------------------------------------
	fadeOut : function() {
		// 不透明度を取得
		var opacity = inputExplainExtension.getOpacity(inputExplainExtension.storage.tooltip);
		if ( opacity > 0 ) {
			// 不透明度セット
			inputExplainExtension.setOpacity(inputExplainExtension.storage.tooltip, opacity-1);
			inputExplainExtension.storage.fadeTimer = window.setTimeout(inputExplainExtension.fadeOut, 50);
		} else {
			// tooltipを非表示
			inputExplainExtension.setOpacity(inputExplainExtension.storage.tooltip, 0);
			inputExplainExtension.storage.tooltip.style.visibility = 'hidden';
			inputExplainExtension.setPosition(inputExplainExtension.storage.tooltip, 0, 0);
			// shimを非表示
			inputExplainExtension.storage.shim.style.visibility = 'hidden';
			inputExplainExtension.setSize(inputExplainExtension.storage.shim, 1, 1);
			inputExplainExtension.setPosition(inputExplainExtension.storage.shim, 0, 0);
		}
	},
	//-----------------------------------------
	// Class名からidを抽出する
	//-----------------------------------------
	getTargetId : function( str ) {
		str = str.replace(inputExplainExtension.conf.targetClass, '');
		str = str.replace('[', '');
		str = str.replace(']', '');
		str = str.split(',');
		return str;
	},
	//-----------------------------------------
	// tooltipを生成する
	//-----------------------------------------
	createTooltip : function() {
		// tooltip生成
		var parentDiv = document.createElement('div');
		switch (inputExplainExtension.conf.tooltipColor) {
			case 'black':
				parentDiv.className = 'explainTooltip blackTooltip';
				break;
			case 'white':
				parentDiv.className = 'explainTooltip whiteTooltip';
				break;
			case 'red':
				parentDiv.className = 'explainTooltip redTooltip';
				break;
			case 'green':
				parentDiv.className = 'explainTooltip greenTooltip';
				break;
			default:
				parentDiv.className = 'explainTooltip blackTooltip';
				break;
		}
		parentDiv.style.zIndex = '200';
		parentDiv.style.visibility = 'hidden';
		document.body.appendChild(parentDiv);
		// content生成
		var contentDiv = document.createElement('div');
		contentDiv.className = 'explainTooltipContent';
		contentDiv.innerHTML = String.fromCharCode(8203);
		parentDiv.appendChild(contentDiv);
		// arrow生成
		var arrowDiv = document.createElement('div');
		arrowDiv.style.zIndex = '201';
		arrowDiv.className = 'explainTooltipArrow';
		for (var i = 10; i > 0; i--) {
			var lineDiv = document.createElement('div');
			lineDiv.className = 'explainLine' + i;
			lineDiv.innerHTML = String.fromCharCode(8203);
			arrowDiv.appendChild(lineDiv);
		}
		parentDiv.appendChild(arrowDiv);
		// 初期位置セット
		inputExplainExtension.setPosition(parentDiv, 0, 0);
		// 保持
		inputExplainExtension.storage.tooltip = parentDiv;
		inputExplainExtension.storage.content = contentDiv;
	},
	//-----------------------------------------
	// shimを生成する
	//-----------------------------------------
	createShim : function() {
		// iframe要素を生成
		var iframe = document.createElement('iframe');
		// スタイルをセット
		iframe.setAttribute('frameBorder', '0');
		iframe.setAttribute('scrolling', 'no');
		iframe.style.border = 'none';
		iframe.style.zIndex = '150';
		iframe.style.visibility = 'hidden';
		inputExplainExtension.setSize(iframe, 1, 1);
		inputExplainExtension.setPosition(iframe, 0, 0);
		inputExplainExtension.setOpacity(iframe, 0);
		document.body.appendChild(iframe);
		// 保持
		inputExplainExtension.storage.shim = iframe;
	},
	//-----------------------------------------
	// 要素の不透明度を取得する
	//-----------------------------------------
	getOpacity : function( element ) {
		var opacity = 0;
		if ( element.alpha ) {
			opacity = element.alpha / 10;
		} else if ( element.style ) {
			if ( element.style.opacity ) {
				opacity = element.style.opacity * 10;
			}
		}
		if ( 0 > opacity ) {
			opacity = 0;
		}
		return opacity;
	},
	//-----------------------------------------
	// 要素の不透明度を設定する
	//-----------------------------------------
	setOpacity : function( element, val ) {
		element.style.opacity = val / 10;
		element.style.filter = 'alpha(opacity=' + val * 10 + ')';
		element.alpha = val * 10;
	},
	//-----------------------------------------
	// 要素のサイズを設定する
	//-----------------------------------------
	setSize : function( element, width, height ) {
		element.style.width = width + 'px';
		element.style.height = height + 'px';
	},
	//-----------------------------------------
	// 要素の位置を設定する
	//-----------------------------------------
	setPosition : function( element, top, left ) {
		element.style.position = 'absolute';
		element.style.top = top + 'px';
		element.style.left = left + 'px';
	},
	//-----------------------------------------
	// 対象要素のポジションを取得する
	//-----------------------------------------
	getElementPosition : function( element ) {
		var offsetTrail = (typeof element == 'string') ? document.getElementById(element): element;
		var x = 0;
		var y = 0;
		while (offsetTrail) {
			x += offsetTrail.offsetLeft;
			y += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}
		if ( navigator.userAgent.indexOf('Mac') != -1 && typeof doc.body.leftMargin != 'undefined' ) {
			x += document.body.leftMargin;
			y += document.body.topMargin;
		}
		return ({ 'left': x, 'top': y });
	},
	//-----------------------------------------
	// 対象要素のサイズを取得する
	//-----------------------------------------
	getElementSize : function( element ) {
		var w = element.offsetWidth;
		var h = element.offsetHeight;
		return ({ 'width': w, 'height': h });
	},
	//-----------------------------------------
	// ターゲットタグをClass名から取得する
	//-----------------------------------------
	getTargetElementsByClassName : function( cls ) {
		var elements = new Array();
		if ( document.evaluate ) {
			var xpathExpression = '/descendant::*[contains(@class,"'+ cls + '")]';
			var iterator = document.evaluate(xpathExpression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			for (var i = 0, len = iterator.snapshotLength; i < len; i++) {
				var elm = iterator.snapshotItem(i);
				elements[elements.length] = elm;
			}
		} else {
			var nodes = document.all ? document.all : document.getElementsByTagName('*');
			for (var i = 0, len = nodes.length; i < len; i++) {
				var elm = nodes.item(i);
				if ( elm.className.match(cls) ) {
					elements[elements.length] = elm;
				}
			}
		}
		return elements;
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		for ( var i = 0, len = targetElements.length; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements[elements.length] = targetElements[i];
			}
		}
		return elements;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
inputExplainExtension.addEvent( window, 'load', inputExplainExtension.init );